<template>
  <apexchart
    :options="chartOptions"
    :series="series"
    type="bar"
    class="w-full"
    :height="cheight"
  />
</template>

<script>
import { mapState } from "vuex";

export default {
  computed: {
    ...mapState(["classifications", "selectedClassification"]),

    cheight() {
      return this.attributeNames.length * 35 + 100;
    },

    classification() {
      return this.classifications[this.selectedClassification];
    },
    attributes() {
      return this.classification.attributes;
    },
    attributeNames() {
      return Object.keys(this.attributes)
        .filter(a => a !== "participant_code")
        .sort((a, b) => {
          return (
            this.attributes[a].contribution < this.attributes[b].contribution
          );
        });
    },
    max_abs_x() {
      return this.yaxis_categories
        .reduce((max, num) => (Math.abs(num) > max ? Math.abs(num) : max))
        .toFixed(1);
    },
    xaxis_categories() {
      return this.attributeNames.map(
        name => `${name.replace(/Q.*_/, "")} = ${this.attributes[name].value}`
      );
    },
    yaxis_categories() {
      return this.attributeNames.map(
        name => this.attributes[name].contribution
      );
    },
    chartOptions() {
      return {
        plotOptions: {
          bar: {
            horizontal: true,
            colors: {
              ranges: [
                {
                  from: -1,
                  to: 0,
                  color: "#ff690a"
                },
                {
                  from: 0,
                  to: 1,
                  color: "#00acac"
                }
              ]
            }
          }
        },
        chart: {
          width: "80%"
        },
        dataLabels: {
          enabled: false
        },
        xaxis: {
          categories: this.xaxis_categories,

          labels: {
            formatter(value) {
              return Math.round(value * 1000) / 1000;
            }
          },

          title: {
            text: "Contribution",
            offsetY: 10,
            style: {
              cssClass: "f-subtitle"
            }
          },

          min: -1 * this.max_abs_x,
          max: 1 * this.max_abs_x
        },
        yaxis: {
          categories: this.yaxis_categories,

          labels: {
            align: "left",
            minWidth: 800
          },

          title: {
            text: "Attribute value",
            rotate: 90,
            style: {
              cssClass: "f-subtitle"
            }
          }
        },
        tooltip: {
          y: {
            formatter(value) {
              return value.toFixed(3);
            }
          }
        }
      };
    },
    series() {
      return [
        {
          name: "Contribution",
          data: this.yaxis_categories
        }
      ];
    }
  }
};
</script>
